# Introduction

## Contributing to Harsh

You're here to help? Awesome! Welcome! Thanks for offering. Please read the following sections to get a feel for the lay of the land, know how to ask questions, and how to work on something.

All contributors are expected to follow our [Code of Conduct](CODE_OF_CONDUCT.md). Please make sure you are welcome and friendly. Be kind. Be respectful. (BKBR). Be nice. It's a tough world out there.

I'm pretty much happy for any contribution though since the idea is to keep the applicaiton minimalist new feature requests will be deliberated before addiiton. Code improvements, bug fixes, tests, documentation, translations, and any sort of unambiguous improvement is most welcome. Please [submit a PR](#pull-requests)

## Get in touch

    Report bugs, suggest features in the Issues on Github and view source on GitHub.
    I'm most easily pinged on twitter viaan @mention to [@awws](https://twitter.com/awws)
    For email, please look at the [About page on Daryl's blog](https://daryl.wakatara.com/about)

## Using the issue tracker

The issue tracker is the preferred channel for [bug reports](#bugs),
[features requests](#features) and [submitting pull
requests](#pull-requests).

### Bug reports

A bug is a _demonstrable problem_ that is caused by the code in the repository.
Good bug reports are extremely helpful.

Guidelines for bug reports:

1. **Use the GitHub issue search** &mdash; check if the issue has already been
   reported.

2. **Check if the issue has been fixed** &mdash; try to reproduce it using the
   latest `master` branch in the repository.

3. **Isolate the problem** &mdash; ideally create a reduced test case.

A good bug report shouldn't leave others needing to chase you up for more
information. Please try to be as detailed as possible in your report. What is
your environment? What steps will reproduce the issue? What OS experiences the
problem? What would you expect to be the outcome? All these details will help
people to fix any potential bugs.

There's a template that should help you out for reporting, but basically think along these lines.

Example:

> Short and descriptive example bug report title
>
> A summary of the issue and the browser/OS environment in which it occurs. If
> suitable, include the steps required to reproduce the bug.
>
> 1. This is the first step
> 2. This is the second step
> 3. Further steps, etc.
>
> `<url>` - a link to the reduced test case
>
> Any other information you want to share that is relevant to the issue being
> reported. This might include the lines of code that you have identified as
> causing the bug, and potential solutions (and your opinions on their
> merits).

### Feature requests

Feature requests are welcome. But take a moment to find out whether your idea
fits with the scope and aims of Harsh. It's up to *you* to make a strong
case to convince the project's developer(s) of the merits of this feature. Please
provide as much detail and context as possible.

### Pull requests

Good pull requests - patches, improvements, new features - are a fantastic
help. They should remain focused in scope and avoid containing unrelated
commits.

**Please ask first** before embarking on any significant pull request (e.g.
implementing features, refactoring code), otherwise you risk spending a lot of
time working on something that the project's developers might not want to merge
into the project.



